# This file is the entry point to configure your own services.
# Files in the packages/ subdirectory configure your dependencies.

# Put parameters here that don't need to change on each machine where the app is deployed
# https://symfony.com/doc/current/best_practices.html#use-parameters-for-application-configuration
parameters:
    # reset password token expiration (in seconds)
    reset_password_expiration: 3600
    upload_directory: '%kernel.project_dir%/var/files'

services:
    # default configuration for services in *this* file
    _defaults:
        autowire: true      # Automatically injects dependencies in your services.
        autoconfigure: true # Automatically registers your services as commands, event subscribers, etc.
        bind:
            $formLoginAuthenticator: '@security.authenticator.form_login.main'

    # makes classes in src/ available to be used as services
    # this creates a service per class whose id is the fully-qualified class name
    App\:
        resource: '../src/'
        exclude: '../src/{DependencyInjection,Entity,Tests,Kernel.php}'

    # add more service definitions when explicit configuration is needed
    # please note that last definitions always *replace* previous ones

    # Menu builder
    App\Menu\MenuBuilder:
        tags:
            - { name: knp_menu.menu_builder, method: createMainMenu, alias: main }

    # Elastica client
    Elastica\Client:
        arguments:
            - { url: '%env(ELASTICSEARCH_URL)%', username: '%env(ELASTICSEARCH_USERNAME)%', password: '%env(ELASTICSEARCH_PASSWORD)%' }

    # Elasticsearch indexes
    App\Elasticsearch\AbstractIndex:
        abstract:  true
        arguments:
            $url: '%env(ELASTICSEARCH_URL)%'
            $username: '%env(ELASTICSEARCH_USERNAME)%'
            $password: '%env(ELASTICSEARCH_PASSWORD)%'

    App\Elasticsearch\DatatourismeIndex:
        parent: App\Elasticsearch\AbstractIndex

    App\Elasticsearch\StatisticsIndex:
        parent: App\Elasticsearch\AbstractIndex

    # Elasticsearch export
    App\Elasticsearch\AbstractExport:
        abstract:  true

    App\Elasticsearch\DatatourismeExport:
      parent: App\Elasticsearch\AbstractExport
      arguments: ['@App\Elasticsearch\DatatourismeIndex']

    App\Service\FileUploader:
        arguments:
            $targetDirectory: '%upload_directory%'

    # SPARQL Client
    App\Service\SparqlClient:
        arguments:
            $url: '%env(SPARQL_ENDPOINT)%'

    # SSO Endpoint
    App\Service\SsoEndpoint:
        arguments:
            $endpoint: '%env(PRODUCER_SSO_ENDPOINT)%'
            $secret: '%env(PRODUCER_SSO_SECRET)%'
            $redirectRoute: 'sso.login'
